/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Contents of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.443 - (hide annotations) (download)
Fri Mar 20 18:22:05 2015 UTC (2 years, 6 months ago) by vapier
Branch: MAIN
Changes since 1.442: +12 -5 lines
epatch: include `patch --version` output in the failure log

1 mgorny 1.442 # Copyright 1999-2015 Gentoo Foundation
2 azarah 1.1 # Distributed under the terms of the GNU General Public License v2
3 vapier 1.443 # $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.442 2015/01/14 22:50:02 mgorny Exp $
4 vapier 1.283
5     # @ECLASS: eutils.eclass
6     # @MAINTAINER:
7     # base-system@gentoo.org
8     # @BLURB: many extra (but common) functions that are used in ebuilds
9     # @DESCRIPTION:
10     # The eutils eclass contains a suite of functions that complement
11     # the ones that ebuild.sh already contain. The idea is that the functions
12     # are not required in all ebuilds but enough utilize them to have a common
13     # home rather than having multiple ebuilds implementing the same thing.
14 swegener 1.286 #
15 vapier 1.283 # Due to the nature of this eclass, some functions may have maintainers
16     # different from the overall eclass!
17 azarah 1.1
18 ulm 1.436 if [[ -z ${_EUTILS_ECLASS} ]]; then
19     _EUTILS_ECLASS=1
20 vapier 1.371
21 vapier 1.431 inherit multilib toolchain-funcs
22 azarah 1.1
23 betelgeuse 1.329 if has "${EAPI:-0}" 0 1 2; then
24    
25 vapier 1.283 # @FUNCTION: epause
26     # @USAGE: [seconds]
27     # @DESCRIPTION:
28     # Sleep for the specified number of seconds (default of 5 seconds). Useful when
29     # printing a message the user should probably be reading and often used in
30     # conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31 betelgeuse 1.329 # don't wait at all. Defined in EAPIs 0 1 and 2.
32 ciaranm 1.98 epause() {
33 vapier 1.245 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34 ciaranm 1.98 }
35    
36 vapier 1.283 # @FUNCTION: ebeep
37     # @USAGE: [number of beeps]
38     # @DESCRIPTION:
39     # Issue the specified number of beeps (default of 5 beeps). Useful when
40     # printing a message the user should probably be reading and often used in
41     # conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42 betelgeuse 1.329 # don't beep at all. Defined in EAPIs 0 1 and 2.
43 ciaranm 1.98 ebeep() {
44     local n
45 vapier 1.245 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 ciaranm 1.98 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47     echo -ne "\a"
48     sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49     echo -ne "\a"
50     sleep 1
51     done
52     fi
53     }
54    
55 reavertm 1.331 else
56    
57 reavertm 1.332 ebeep() {
58 reavertm 1.337 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59 reavertm 1.332 }
60 reavertm 1.331
61 reavertm 1.332 epause() {
62 reavertm 1.337 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63 reavertm 1.332 }
64 reavertm 1.331
65 betelgeuse 1.329 fi
66    
67 betelgeuse 1.348 # @FUNCTION: eqawarn
68     # @USAGE: [message]
69     # @DESCRIPTION:
70 mgorny 1.363 # Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71     # implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72     # profile.
73 betelgeuse 1.348 if ! declare -F eqawarn >/dev/null ; then
74     eqawarn() {
75 mgorny 1.363 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 ferringb 1.370 :
77 betelgeuse 1.348 }
78     fi
79    
80 hollow 1.298 # @FUNCTION: ecvs_clean
81 vapier 1.299 # @USAGE: [list of dirs]
82 hollow 1.298 # @DESCRIPTION:
83 vapier 1.299 # Remove CVS directories recursiveley. Useful when a source tarball contains
84     # internal CVS directories. Defaults to $PWD.
85 hollow 1.298 ecvs_clean() {
86 vapier 1.299 [[ -z $* ]] && set -- .
87 hollow 1.298 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88     find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89     }
90    
91     # @FUNCTION: esvn_clean
92 vapier 1.299 # @USAGE: [list of dirs]
93 hollow 1.298 # @DESCRIPTION:
94 vapier 1.299 # Remove .svn directories recursiveley. Useful when a source tarball contains
95     # internal Subversion directories. Defaults to $PWD.
96 hollow 1.298 esvn_clean() {
97 vapier 1.299 [[ -z $* ]] && set -- .
98 hollow 1.298 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99     }
100    
101 vapier 1.373 # @FUNCTION: estack_push
102     # @USAGE: <stack> [items to push]
103     # @DESCRIPTION:
104     # Push any number of items onto the specified stack. Pick a name that
105     # is a valid variable (i.e. stick to alphanumerics), and push as many
106     # items as you like onto the stack at once.
107     #
108     # The following code snippet will echo 5, then 4, then 3, then ...
109     # @CODE
110     # estack_push mystack 1 2 3 4 5
111     # while estack_pop mystack i ; do
112     # echo "${i}"
113     # done
114     # @CODE
115     estack_push() {
116     [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 ulm 1.436 local stack_name="_ESTACK_$1_" ; shift
118 vapier 1.373 eval ${stack_name}+=\( \"\$@\" \)
119     }
120    
121     # @FUNCTION: estack_pop
122     # @USAGE: <stack> [variable]
123     # @DESCRIPTION:
124     # Pop a single item off the specified stack. If a variable is specified,
125     # the popped item is stored there. If no more items are available, return
126     # 1, else return 0. See estack_push for more info.
127     estack_pop() {
128     [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129    
130 ulm 1.436 # We use the fugly _estack_xxx var names to avoid collision with
131 vapier 1.373 # passing back the return value. If we used "local i" and the
132     # caller ran `estack_pop ... i`, we'd end up setting the local
133 ulm 1.436 # copy of "i" rather than the caller's copy. The _estack_xxx
134 vapier 1.373 # garbage is preferable to using $1/$2 everywhere as that is a
135     # bit harder to read.
136 ulm 1.436 local _estack_name="_ESTACK_$1_" ; shift
137     local _estack_retvar=$1 ; shift
138     eval local _estack_i=\${#${_estack_name}\[@\]}
139 vapier 1.373 # Don't warn -- let the caller interpret this as a failure
140     # or as normal behavior (akin to `shift`)
141 ulm 1.436 [[ $(( --_estack_i )) -eq -1 ]] && return 1
142 vapier 1.373
143 ulm 1.436 if [[ -n ${_estack_retvar} ]] ; then
144     eval ${_estack_retvar}=\"\${${_estack_name}\[${_estack_i}\]}\"
145 vapier 1.373 fi
146 ulm 1.436 eval unset ${_estack_name}\[${_estack_i}\]
147 vapier 1.373 }
148    
149 vapier 1.423 # @FUNCTION: evar_push
150     # @USAGE: <variable to save> [more vars to save]
151     # @DESCRIPTION:
152     # This let's you temporarily modify a variable and then restore it (including
153     # set vs unset semantics). Arrays are not supported at this time.
154     #
155     # This is meant for variables where using `local` does not work (such as
156     # exported variables, or only temporarily changing things in a func).
157     #
158     # For example:
159     # @CODE
160     # evar_push LC_ALL
161     # export LC_ALL=C
162     # ... do some stuff that needs LC_ALL=C set ...
163     # evar_pop
164     #
165     # # You can also save/restore more than one var at a time
166     # evar_push BUTTERFLY IN THE SKY
167     # ... do stuff with the vars ...
168     # evar_pop # This restores just one var, SKY
169     # ... do more stuff ...
170     # evar_pop 3 # This pops the remaining 3 vars
171     # @CODE
172     evar_push() {
173     local var val
174     for var ; do
175     [[ ${!var+set} == "set" ]] \
176     && val=${!var} \
177 ulm 1.436 || val="unset_76fc3c462065bb4ca959f939e6793f94"
178 vapier 1.423 estack_push evar "${var}" "${val}"
179     done
180     }
181    
182     # @FUNCTION: evar_push_set
183     # @USAGE: <variable to save> [new value to store]
184     # @DESCRIPTION:
185     # This is a handy shortcut to save and temporarily set a variable. If a value
186     # is not specified, the var will be unset.
187     evar_push_set() {
188     local var=$1
189     evar_push ${var}
190     case $# in
191     1) unset ${var} ;;
192     2) printf -v "${var}" '%s' "$2" ;;
193     *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194     esac
195     }
196    
197     # @FUNCTION: evar_pop
198     # @USAGE: [number of vars to restore]
199     # @DESCRIPTION:
200     # Restore the variables to the state saved with the corresponding
201     # evar_push call. See that function for more details.
202     evar_pop() {
203     local cnt=${1:-bad}
204     case $# in
205     0) cnt=1 ;;
206     1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207     *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208     esac
209    
210     local var val
211     while (( cnt-- )) ; do
212     estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213     estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 ulm 1.436 [[ ${val} == "unset_76fc3c462065bb4ca959f939e6793f94" ]] \
215 vapier 1.423 && unset ${var} \
216     || printf -v "${var}" '%s' "${val}"
217     done
218     }
219    
220 vapier 1.322 # @FUNCTION: eshopts_push
221 vapier 1.330 # @USAGE: [options to `set` or `shopt`]
222 vapier 1.322 # @DESCRIPTION:
223     # Often times code will want to enable a shell option to change code behavior.
224     # Since changing shell options can easily break other pieces of code (which
225     # assume the default state), eshopts_push is used to (1) push the current shell
226     # options onto a stack and (2) pass the specified arguments to set.
227     #
228 vapier 1.330 # If the first argument is '-s' or '-u', we assume you want to call `shopt`
229     # rather than `set` as there are some options only available via that.
230     #
231 vapier 1.322 # A common example is to disable shell globbing so that special meaning/care
232     # may be used with variables/arguments to custom functions. That would be:
233     # @CODE
234 vapier 1.438 # eshopts_push -o noglob
235 vapier 1.322 # for x in ${foo} ; do
236     # if ...some check... ; then
237     # eshopts_pop
238     # return 0
239     # fi
240     # done
241     # eshopts_pop
242     # @CODE
243     eshopts_push() {
244 vapier 1.330 if [[ $1 == -[su] ]] ; then
245 vapier 1.376 estack_push eshopts "$(shopt -p)"
246 vapier 1.330 [[ $# -eq 0 ]] && return 0
247 vapier 1.375 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 vapier 1.330 else
249 vapier 1.376 estack_push eshopts $-
250 vapier 1.330 [[ $# -eq 0 ]] && return 0
251 vapier 1.375 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 vapier 1.330 fi
253 vapier 1.322 }
254    
255     # @FUNCTION: eshopts_pop
256     # @USAGE:
257     # @DESCRIPTION:
258     # Restore the shell options to the state saved with the corresponding
259     # eshopts_push call. See that function for more details.
260     eshopts_pop() {
261 vapier 1.376 local s
262     estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 vapier 1.330 if [[ ${s} == "shopt -"* ]] ; then
264 vapier 1.375 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 vapier 1.330 else
266 vapier 1.375 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267     set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 vapier 1.330 fi
269 vapier 1.322 }
270    
271 vapier 1.373 # @FUNCTION: eumask_push
272     # @USAGE: <new umask>
273     # @DESCRIPTION:
274     # Set the umask to the new value specified while saving the previous
275     # value onto a stack. Useful for temporarily changing the umask.
276     eumask_push() {
277     estack_push eumask "$(umask)"
278     umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279     }
280    
281     # @FUNCTION: eumask_pop
282     # @USAGE:
283     # @DESCRIPTION:
284     # Restore the previous umask state.
285     eumask_pop() {
286 vapier 1.382 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 vapier 1.373 local s
288     estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289     umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290     }
291    
292 vapier 1.422 # @FUNCTION: isdigit
293     # @USAGE: <number> [more numbers]
294     # @DESCRIPTION:
295     # Return true if all arguments are numbers.
296     isdigit() {
297     local d
298     for d ; do
299     [[ ${d:-bad} == *[!0-9]* ]] && return 1
300     done
301     return 0
302     }
303    
304 vapier 1.325 # @VARIABLE: EPATCH_SOURCE
305     # @DESCRIPTION:
306     # Default directory to search for patches.
307 azarah 1.2 EPATCH_SOURCE="${WORKDIR}/patch"
308 vapier 1.325 # @VARIABLE: EPATCH_SUFFIX
309     # @DESCRIPTION:
310     # Default extension for patches (do not prefix the period yourself).
311 azarah 1.2 EPATCH_SUFFIX="patch.bz2"
312 vapier 1.325 # @VARIABLE: EPATCH_OPTS
313     # @DESCRIPTION:
314 vapier 1.391 # Options to pass to patch. Meant for ebuild/package-specific tweaking
315     # such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316     # for single patch tweaking, you can also pass flags directly to epatch.
317     EPATCH_OPTS=""
318     # @VARIABLE: EPATCH_COMMON_OPTS
319     # @DESCRIPTION:
320     # Common options to pass to `patch`. You probably should never need to
321     # change these. If you do, please discuss it with base-system first to
322     # be sure.
323 vapier 1.325 # @CODE
324     # -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325     # --no-backup-if-mismatch - do not leave .orig files behind
326     # -E - automatically remove empty files
327     # @CODE
328 vapier 1.391 EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329 vapier 1.325 # @VARIABLE: EPATCH_EXCLUDE
330     # @DESCRIPTION:
331 mr_bones_ 1.308 # List of patches not to apply. Note this is only file names,
332 vapier 1.325 # and not the full path. Globs accepted.
333 azarah 1.6 EPATCH_EXCLUDE=""
334 vapier 1.325 # @VARIABLE: EPATCH_SINGLE_MSG
335     # @DESCRIPTION:
336 azarah 1.9 # Change the printed message for a single patch.
337     EPATCH_SINGLE_MSG=""
338 vapier 1.325 # @VARIABLE: EPATCH_MULTI_MSG
339     # @DESCRIPTION:
340 vapier 1.173 # Change the printed message for multiple patches.
341     EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342 vapier 1.325 # @VARIABLE: EPATCH_FORCE
343     # @DESCRIPTION:
344     # Only require patches to match EPATCH_SUFFIX rather than the extended
345     # arch naming style.
346 azarah 1.29 EPATCH_FORCE="no"
347 vapier 1.416 # @VARIABLE: EPATCH_USER_EXCLUDE
348     # @DEFAULT_UNSET
349     # @DESCRIPTION:
350     # List of patches not to apply. Note this is only file names,
351     # and not the full path. Globs accepted.
352 azarah 1.2
353 vapier 1.325 # @FUNCTION: epatch
354 vapier 1.391 # @USAGE: [options] [patches] [dirs of patches]
355 vapier 1.325 # @DESCRIPTION:
356     # epatch is designed to greatly simplify the application of patches. It can
357     # process patch files directly, or directories of patches. The patches may be
358     # compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359 vapier 1.425 # the -p option as epatch will automatically attempt -p0 to -p4 until things
360 vapier 1.325 # apply successfully.
361 azarah 1.2 #
362 vapier 1.391 # If you do not specify any patches/dirs, then epatch will default to the
363     # directory specified by EPATCH_SOURCE.
364     #
365     # Any options specified that start with a dash will be passed down to patch
366     # for this specific invocation. As soon as an arg w/out a dash is found, then
367     # arg processing stops.
368 azarah 1.2 #
369 vapier 1.325 # When processing directories, epatch will apply all patches that match:
370     # @CODE
371 vapier 1.350 # if ${EPATCH_FORCE} != "yes"
372 vapier 1.325 # ??_${ARCH}_foo.${EPATCH_SUFFIX}
373     # else
374     # *.${EPATCH_SUFFIX}
375     # @CODE
376     # The leading ?? are typically numbers used to force consistent patch ordering.
377     # The arch field is used to apply patches only for the host architecture with
378     # the special value of "all" means apply for everyone. Note that using values
379     # other than "all" is highly discouraged -- you should apply patches all the
380     # time and let architecture details be detected at configure/compile time.
381 azarah 1.2 #
382 vapier 1.325 # If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383     # for patches to apply.
384 azarah 1.2 #
385 vapier 1.325 # Refer to the other EPATCH_xxx variables for more customization of behavior.
386 azarah 1.2 epatch() {
387 swegener 1.231 _epatch_draw_line() {
388 vapier 1.325 # create a line of same length as input string
389 agriffis 1.229 [[ -z $1 ]] && set "$(printf "%65s" '')"
390     echo "${1//?/=}"
391 vapier 1.219 }
392 azarah 1.3
393 vapier 1.195 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
394    
395 vapier 1.391 # First process options. We localize the EPATCH_OPTS setting
396     # from above so that we can pass it on in the loop below with
397     # any additional values the user has specified.
398     local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399     while [[ $# -gt 0 ]] ; do
400     case $1 in
401     -*) EPATCH_OPTS+=( "$1" ) ;;
402     *) break ;;
403     esac
404     shift
405     done
406    
407 vapier 1.325 # Let the rest of the code process one user arg at a time --
408     # each arg may expand into multiple patches, and each arg may
409     # need to start off with the default global EPATCH_xxx values
410     if [[ $# -gt 1 ]] ; then
411     local m
412 vapier 1.94 for m in "$@" ; do
413     epatch "${m}"
414     done
415     return 0
416 azarah 1.3 fi
417    
418 vapier 1.325 local SINGLE_PATCH="no"
419     # no args means process ${EPATCH_SOURCE}
420     [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
421    
422     if [[ -f $1 ]] ; then
423 azarah 1.3 SINGLE_PATCH="yes"
424 vapier 1.325 set -- "$1"
425     # Use the suffix from the single patch (localize it); the code
426     # below will find the suffix for us
427     local EPATCH_SUFFIX=$1
428    
429     elif [[ -d $1 ]] ; then
430 vapier 1.424 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
431     evar_push_set LC_COLLATE C
432     # Some people like to make dirs of patches w/out suffixes (vim).
433 vapier 1.325 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 vapier 1.424 evar_pop
435 danarmak 1.32
436 vapier 1.359 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437     # Re-use EPATCH_SOURCE as a search dir
438     epatch "${EPATCH_SOURCE}/$1"
439     return $?
440    
441 azarah 1.3 else
442 vapier 1.325 # sanity check ... if it isn't a dir or file, wtf man ?
443     [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444     echo
445     eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
446     eerror
447     eerror " ${EPATCH_SOURCE}"
448     eerror " ( ${EPATCH_SOURCE##*/} )"
449     echo
450     die "Cannot find \$EPATCH_SOURCE!"
451 azarah 1.3 fi
452 azarah 1.2
453 vapier 1.391 # Now that we know we're actually going to apply something, merge
454     # all of the patch options back in to a single variable for below.
455     EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456    
457 vapier 1.325 local PIPE_CMD
458 azarah 1.2 case ${EPATCH_SUFFIX##*\.} in
459 vapier 1.325 xz) PIPE_CMD="xz -dc" ;;
460     lzma) PIPE_CMD="lzma -dc" ;;
461     bz2) PIPE_CMD="bzip2 -dc" ;;
462     gz|Z|z) PIPE_CMD="gzip -dc" ;;
463     ZIP|zip) PIPE_CMD="unzip -p" ;;
464     *) ;;
465 azarah 1.2 esac
466    
467 vapier 1.325 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468    
469     local x
470     for x in "$@" ; do
471     # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472     # didn't match anything, ignore continue on
473     [[ ! -f ${x} ]] && continue
474    
475     local patchname=${x##*/}
476    
477     # Apply single patches, or forced sets of patches, or
478     # patches with ARCH dependant names.
479 flameeyes 1.266 # ???_arch_foo.patch
480 vapier 1.325 # Else, skip this input altogether
481     local a=${patchname#*_} # strip the ???_
482     a=${a%%_*} # strip the _foo.patch
483     if ! [[ ${SINGLE_PATCH} == "yes" || \
484 ulm 1.354 ${EPATCH_FORCE} == "yes" || \
485     ${a} == all || \
486     ${a} == ${ARCH} ]]
487 azarah 1.2 then
488 vapier 1.325 continue
489     fi
490 azarah 1.6
491 vapier 1.325 # Let people filter things dynamically
492 vapier 1.437 if [[ -n ${EPATCH_EXCLUDE}${EPATCH_USER_EXCLUDE} ]] ; then
493 vapier 1.325 # let people use globs in the exclude
494     eshopts_push -o noglob
495    
496 scarabeus 1.328 local ex
497 vapier 1.325 for ex in ${EPATCH_EXCLUDE} ; do
498 scarabeus 1.328 if [[ ${patchname} == ${ex} ]] ; then
499 vapier 1.416 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500     eshopts_pop
501     continue 2
502     fi
503     done
504    
505     for ex in ${EPATCH_USER_EXCLUDE} ; do
506     if [[ ${patchname} == ${ex} ]] ; then
507     einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508 scarabeus 1.328 eshopts_pop
509     continue 2
510     fi
511 vapier 1.325 done
512 vapier 1.326
513 vapier 1.325 eshopts_pop
514     fi
515 danarmak 1.32
516 vapier 1.325 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517     if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518     einfo "${EPATCH_SINGLE_MSG}"
519 azarah 1.3 else
520 vapier 1.325 einfo "Applying ${patchname} ..."
521 azarah 1.3 fi
522 vapier 1.325 else
523     einfo " ${patchname} ..."
524     fi
525 azarah 1.2
526 vapier 1.443 # Handle aliased patch command #404447 #461568
527     local patch="patch"
528     eval $(alias patch 2>/dev/null | sed 's:^alias ::')
529    
530 vapier 1.325 # most of the time, there will only be one run per unique name,
531     # but if there are more, make sure we get unique log filenames
532     local STDERR_TARGET="${T}/${patchname}.out"
533     if [[ -e ${STDERR_TARGET} ]] ; then
534     STDERR_TARGET="${T}/${patchname}-$$.out"
535     fi
536 azarah 1.2
537 vapier 1.443 printf "***** %s *****\nPWD: %s\nPATCH TOOL: %s -> %s\nVERSION INFO:\n%s\n\n" \
538     "${patchname}" \
539     "${PWD}" \
540     "${patch}" \
541     "$(type -P "${patch}")" \
542     "$(${patch} --version)" \
543     > "${STDERR_TARGET}"
544 vapier 1.304
545 vapier 1.325 # Decompress the patch if need be
546     local count=0
547     local PATCH_TARGET
548     if [[ -n ${PIPE_CMD} ]] ; then
549     PATCH_TARGET="${T}/$$.patch"
550     echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
551 vapier 1.304
552 vapier 1.325 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
553     echo
554     eerror "Could not extract patch!"
555     #die "Could not extract patch!"
556     count=5
557     break
558 vapier 1.305 fi
559 vapier 1.325 else
560     PATCH_TARGET=${x}
561     fi
562 vapier 1.305
563 vapier 1.325 # Check for absolute paths in patches. If sandbox is disabled,
564     # people could (accidently) patch files in the root filesystem.
565     # Or trigger other unpleasantries #237667. So disallow -p0 on
566     # such patches.
567     local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
568     if [[ -n ${abs_paths} ]] ; then
569     count=1
570     printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
571     fi
572 vapier 1.353 # Similar reason, but with relative paths.
573     local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
574     if [[ -n ${rel_paths} ]] ; then
575 vapier 1.419 echo
576     eerror "Rejected Patch: ${patchname} !"
577     eerror " ( ${PATCH_TARGET} )"
578     eerror
579     eerror "Your patch uses relative paths '../':"
580     eerror "${rel_paths}"
581     echo
582     die "you need to fix the relative paths in patch"
583 vapier 1.353 fi
584 vapier 1.325
585     # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
586 vapier 1.383 local patch_cmd
587 vapier 1.325 while [[ ${count} -lt 5 ]] ; do
588 vapier 1.417 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
589 vapier 1.383
590 vapier 1.325 # Generate some useful debug info ...
591     (
592     _epatch_draw_line "***** ${patchname} *****"
593     echo
594 vapier 1.383 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
595 vapier 1.325 echo
596     _epatch_draw_line "***** ${patchname} *****"
597 vapier 1.383 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
598 vapier 1.360 ret=$?
599     echo
600     echo "patch program exited with status ${ret}"
601     exit ${ret}
602 vapier 1.325 ) >> "${STDERR_TARGET}"
603 azarah 1.8
604 vapier 1.360 if [ $? -eq 0 ] ; then
605 vapier 1.325 (
606     _epatch_draw_line "***** ${patchname} *****"
607     echo
608     echo "ACTUALLY APPLYING ${patchname} ..."
609     echo
610     _epatch_draw_line "***** ${patchname} *****"
611 vapier 1.383 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
612 vapier 1.360 ret=$?
613     echo
614     echo "patch program exited with status ${ret}"
615     exit ${ret}
616 vapier 1.325 ) >> "${STDERR_TARGET}"
617 danarmak 1.32
618 vapier 1.325 if [ $? -ne 0 ] ; then
619     echo
620     eerror "A dry-run of patch command succeeded, but actually"
621     eerror "applying the patch failed!"
622     #die "Real world sux compared to the dreamworld!"
623     count=5
624 azarah 1.2 fi
625 vapier 1.325 break
626 azarah 1.8 fi
627    
628 vapier 1.325 : $(( count++ ))
629     done
630 azarah 1.8
631 vapier 1.325 # if we had to decompress the patch, delete the temp one
632     if [[ -n ${PIPE_CMD} ]] ; then
633     rm -f "${PATCH_TARGET}"
634     fi
635 azarah 1.3
636 vapier 1.325 if [[ ${count} -ge 5 ]] ; then
637     echo
638     eerror "Failed Patch: ${patchname} !"
639     eerror " ( ${PATCH_TARGET} )"
640     eerror
641     eerror "Include in your bugreport the contents of:"
642     eerror
643     eerror " ${STDERR_TARGET}"
644     echo
645     die "Failed Patch: ${patchname}!"
646 azarah 1.2 fi
647 vapier 1.325
648 vapier 1.383 # if everything worked, delete the full debug patch log
649 vapier 1.325 rm -f "${STDERR_TARGET}"
650 vapier 1.383
651     # then log away the exact stuff for people to review later
652     cat <<-EOF >> "${T}/epatch.log"
653     PATCH: ${x}
654     CMD: ${patch_cmd}
655     PWD: ${PWD}
656    
657     EOF
658 vapier 1.325 eend 0
659 azarah 1.2 done
660 vapier 1.325
661     [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
662     : # everything worked
663 azarah 1.26 }
664 vapier 1.361
665     # @FUNCTION: epatch_user
666     # @USAGE:
667     # @DESCRIPTION:
668     # Applies user-provided patches to the source tree. The patches are
669 vapier 1.434 # taken from /etc/portage/patches/<CATEGORY>/<P-PR|P|PN>[:SLOT]/, where the first
670 vapier 1.361 # of these three directories to exist will be the one to use, ignoring
671 vapier 1.387 # any more general directories which might exist as well. They must end
672     # in ".patch" to be applied.
673 vapier 1.361 #
674     # User patches are intended for quick testing of patches without ebuild
675     # modifications, as well as for permanent customizations a user might
676     # desire. Obviously, there can be no official support for arbitrarily
677     # patched ebuilds. So whenever a build log in a bug report mentions that
678     # user patches were applied, the user should be asked to reproduce the
679     # problem without these.
680     #
681     # Not all ebuilds do call this function, so placing patches in the
682     # stated directory might or might not work, depending on the package and
683     # the eclasses it inherits and uses. It is safe to call the function
684     # repeatedly, so it is always possible to add a call at the ebuild
685     # level. The first call is the time when the patches will be
686     # applied.
687     #
688     # Ideally, this function should be called after gentoo-specific patches
689     # have been applied, so that their code can be modified as well, but
690     # before calls to e.g. eautoreconf, as the user patches might affect
691     # autotool input files as well.
692 vapier 1.318 epatch_user() {
693     [[ $# -ne 0 ]] && die "epatch_user takes no options"
694    
695 vapier 1.361 # Allow multiple calls to this function; ignore all but the first
696 vapier 1.383 local applied="${T}/epatch_user.log"
697 vapier 1.361 [[ -e ${applied} ]] && return 2
698    
699 vapier 1.318 # don't clobber any EPATCH vars that the parent might want
700 zmedico 1.323 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
701 vapier 1.406 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
702 vapier 1.318 EPATCH_SOURCE=${base}/${CTARGET}/${check}
703     [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
704     [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
705     if [[ -d ${EPATCH_SOURCE} ]] ; then
706     EPATCH_SOURCE=${EPATCH_SOURCE} \
707     EPATCH_SUFFIX="patch" \
708     EPATCH_FORCE="yes" \
709     EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
710     epatch
711 vapier 1.361 echo "${EPATCH_SOURCE}" > "${applied}"
712 vapier 1.349 return 0
713 vapier 1.318 fi
714     done
715 vapier 1.361 echo "none" > "${applied}"
716 vapier 1.349 return 1
717 vapier 1.318 }
718 azarah 1.26
719 vapier 1.283 # @FUNCTION: emktemp
720     # @USAGE: [temp dir]
721     # @DESCRIPTION:
722 vapier 1.52 # Cheap replacement for when debianutils (and thus mktemp)
723 vapier 1.283 # does not exist on the users system.
724 vapier 1.117 emktemp() {
725 vapier 1.119 local exe="touch"
726 vapier 1.194 [[ $1 == -d ]] && exe="mkdir" && shift
727     local topdir=$1
728 mr_bones_ 1.100
729 vapier 1.194 if [[ -z ${topdir} ]] ; then
730     [[ -z ${T} ]] \
731 vapier 1.117 && topdir="/tmp" \
732 vapier 1.194 || topdir=${T}
733 vapier 1.117 fi
734    
735 vapier 1.280 if ! type -P mktemp > /dev/null ; then
736     # system lacks `mktemp` so we have to fake it
737 vapier 1.117 local tmp=/
738 vapier 1.194 while [[ -e ${tmp} ]] ; do
739     tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
740 vapier 1.117 done
741 vapier 1.194 ${exe} "${tmp}" || ${exe} -p "${tmp}"
742 vapier 1.117 echo "${tmp}"
743 vapier 1.52 else
744 vapier 1.280 # the args here will give slightly wierd names on BSD,
745     # but should produce a usable file on all userlands
746 flameeyes 1.223 if [[ ${exe} == "touch" ]] ; then
747 vapier 1.280 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
748 flameeyes 1.223 else
749 vapier 1.280 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
750 flameeyes 1.223 fi
751 vapier 1.52 fi
752     }
753    
754 vapier 1.283 # @FUNCTION: edos2unix
755     # @USAGE: <file> [more files ...]
756     # @DESCRIPTION:
757     # A handy replacement for dos2unix, recode, fixdos, etc... This allows you
758     # to remove all of these text utilities from DEPEND variables because this
759     # is a script based solution. Just give it a list of files to convert and
760     # they will all be changed from the DOS CRLF format to the UNIX LF format.
761 vapier 1.24 edos2unix() {
762 vapier 1.366 [[ $# -eq 0 ]] && return 0
763     sed -i 's/\r$//' -- "$@" || die
764 vapier 1.39 }
765    
766 jlec 1.377 # @FUNCTION: make_desktop_entry
767     # @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
768     # @DESCRIPTION:
769     # Make a .desktop file.
770     #
771     # @CODE
772     # binary: what command does the app run with ?
773     # name: the name that will show up in the menu
774 vapier 1.401 # icon: the icon to use in the menu entry
775 jlec 1.377 # this can be relative (to /usr/share/pixmaps) or
776     # a full path to an icon
777     # type: what kind of application is this?
778     # for categories:
779     # http://standards.freedesktop.org/menu-spec/latest/apa.html
780     # if unset, function tries to guess from package's category
781 vapier 1.341 # fields: extra fields to append to the desktop file; a printf string
782 jlec 1.377 # @CODE
783 vapier 1.39 make_desktop_entry() {
784 vapier 1.341 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
785 vapier 1.39
786 vapier 1.158 local exec=${1}
787     local name=${2:-${PN}}
788 wolf31o2 1.293 local icon=${3:-${PN}}
789 vapier 1.158 local type=${4}
790 vapier 1.341 local fields=${5}
791 vapier 1.158
792     if [[ -z ${type} ]] ; then
793     local catmaj=${CATEGORY%%-*}
794     local catmin=${CATEGORY##*-}
795     case ${catmaj} in
796     app)
797     case ${catmin} in
798 pacho 1.384 accessibility) type="Utility;Accessibility";;
799 vapier 1.338 admin) type=System;;
800     antivirus) type=System;;
801 pacho 1.384 arch) type="Utility;Archiving";;
802     backup) type="Utility;Archiving";;
803     cdr) type="AudioVideo;DiscBurning";;
804     dicts) type="Office;Dictionary";;
805 vapier 1.338 doc) type=Documentation;;
806 pacho 1.384 editors) type="Utility;TextEditor";;
807     emacs) type="Development;TextEditor";;
808     emulation) type="System;Emulator";;
809     laptop) type="Settings;HardwareSettings";;
810 vapier 1.338 office) type=Office;;
811 pacho 1.384 pda) type="Office;PDA";;
812     vim) type="Development;TextEditor";;
813     xemacs) type="Development;TextEditor";;
814 vapier 1.158 esac
815 azarah 1.59 ;;
816 vapier 1.158
817     dev)
818 vapier 1.159 type="Development"
819 vapier 1.158 ;;
820    
821     games)
822     case ${catmin} in
823 wolf31o2 1.265 action|fps) type=ActionGame;;
824 vapier 1.338 arcade) type=ArcadeGame;;
825     board) type=BoardGame;;
826     emulation) type=Emulator;;
827     kids) type=KidsGame;;
828     puzzle) type=LogicGame;;
829     roguelike) type=RolePlaying;;
830     rpg) type=RolePlaying;;
831 vapier 1.158 simulation) type=Simulation;;
832 vapier 1.338 sports) type=SportsGame;;
833     strategy) type=StrategyGame;;
834 vapier 1.158 esac
835 vapier 1.159 type="Game;${type}"
836 vapier 1.158 ;;
837    
838 vapier 1.284 gnome)
839     type="Gnome;GTK"
840     ;;
841    
842     kde)
843     type="KDE;Qt"
844     ;;
845    
846 vapier 1.158 mail)
847 vapier 1.159 type="Network;Email"
848 vapier 1.158 ;;
849    
850     media)
851     case ${catmin} in
852 vapier 1.339 gfx)
853     type=Graphics
854     ;;
855     *)
856     case ${catmin} in
857     radio) type=Tuner;;
858     sound) type=Audio;;
859     tv) type=TV;;
860     video) type=Video;;
861     esac
862     type="AudioVideo;${type}"
863     ;;
864 vapier 1.158 esac
865 wolf31o2 1.65 ;;
866 vapier 1.158
867     net)
868     case ${catmin} in
869     dialup) type=Dialup;;
870 vapier 1.338 ftp) type=FileTransfer;;
871     im) type=InstantMessaging;;
872     irc) type=IRCClient;;
873     mail) type=Email;;
874     news) type=News;;
875     nntp) type=News;;
876     p2p) type=FileTransfer;;
877     voip) type=Telephony;;
878 vapier 1.158 esac
879 vapier 1.159 type="Network;${type}"
880 vapier 1.158 ;;
881    
882     sci)
883     case ${catmin} in
884 vapier 1.284 astro*) type=Astronomy;;
885 vapier 1.338 bio*) type=Biology;;
886     calc*) type=Calculator;;
887     chem*) type=Chemistry;;
888 vapier 1.284 elec*) type=Electronics;;
889 vapier 1.338 geo*) type=Geology;;
890     math*) type=Math;;
891 vapier 1.284 physics) type=Physics;;
892     visual*) type=DataVisualization;;
893 vapier 1.159 esac
894 abcd 1.336 type="Education;Science;${type}"
895 vapier 1.158 ;;
896    
897 vapier 1.284 sys)
898     type="System"
899     ;;
900    
901 vapier 1.158 www)
902     case ${catmin} in
903     client) type=WebBrowser;;
904     esac
905 abcd 1.336 type="Network;${type}"
906 azarah 1.59 ;;
907 vapier 1.158
908 azarah 1.59 *)
909     type=
910     ;;
911 vapier 1.39 esac
912     fi
913 vapier 1.440 local slot=${SLOT%/*}
914     if [[ ${slot} == "0" ]] ; then
915 carlo 1.177 local desktop_name="${PN}"
916     else
917 vapier 1.440 local desktop_name="${PN}-${slot}"
918 carlo 1.177 fi
919 vapier 1.272 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
920 vapier 1.271 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
921 vapier 1.39
922 abcd 1.336 # Don't append another ";" when a valid category value is provided.
923     type=${type%;}${type:+;}
924    
925     eshopts_push -s extglob
926     if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
927     ewarn "As described in the Icon Theme Specification, icon file extensions are not"
928     ewarn "allowed in .desktop files if the value is not an absolute path."
929     icon=${icon%.@(xpm|png|svg)}
930     fi
931     eshopts_pop
932    
933 vapier 1.271 cat <<-EOF > "${desktop}"
934     [Desktop Entry]
935     Name=${name}
936     Type=Application
937     Comment=${DESCRIPTION}
938     Exec=${exec}
939     TryExec=${exec%% *}
940     Icon=${icon}
941 abcd 1.336 Categories=${type}
942 vapier 1.271 EOF
943 vapier 1.39
944 vapier 1.341 if [[ ${fields:-=} != *=* ]] ; then
945     # 5th arg used to be value to Path=
946     ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
947     fields="Path=${fields}"
948     fi
949 vapier 1.342 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
950 wolf31o2 1.293
951 vapier 1.204 (
952     # wrap the env here so that the 'insinto' call
953     # doesn't corrupt the env of the caller
954     insinto /usr/share/applications
955     doins "${desktop}"
956 vapier 1.340 ) || die "installing desktop file failed"
957 danarmak 1.32 }
958    
959 vapier 1.428 # @FUNCTION: _eutils_eprefix_init
960     # @INTERNAL
961     # @DESCRIPTION:
962 ulm 1.435 # Initialized prefix variables for EAPI<3.
963 vapier 1.428 _eutils_eprefix_init() {
964     has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
965     }
966    
967 vapier 1.283 # @FUNCTION: validate_desktop_entries
968     # @USAGE: [directories]
969     # @MAINTAINER:
970     # Carsten Lohrke <carlo@gentoo.org>
971     # @DESCRIPTION:
972 carlo 1.278 # Validate desktop entries using desktop-file-utils
973 carlo 1.277 validate_desktop_entries() {
974 vapier 1.428 _eutils_eprefix_init
975     if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
976 carlo 1.277 einfo "Checking desktop entry validity"
977     local directories=""
978 carlo 1.279 for d in /usr/share/applications $@ ; do
979 vapier 1.428 [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
980 carlo 1.277 done
981 carlo 1.279 if [[ -n ${directories} ]] ; then
982     for FILE in $(find ${directories} -name "*\.desktop" \
983     -not -path '*.hidden*' | sort -u 2>/dev/null)
984     do
985     local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
986     sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
987 vapier 1.428 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
988 carlo 1.279 done
989     fi
990 carlo 1.277 echo ""
991     else
992     einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
993     fi
994     }
995    
996 vapier 1.283 # @FUNCTION: make_session_desktop
997 vapier 1.314 # @USAGE: <title> <command> [command args...]
998 vapier 1.283 # @DESCRIPTION:
999     # Make a GDM/KDM Session file. The title is the file to execute to start the
1000     # Window Manager. The command is the name of the Window Manager.
1001 vapier 1.314 #
1002     # You can set the name of the file via the ${wm} variable.
1003 lanius 1.133 make_session_desktop() {
1004 vapier 1.314 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1005     [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1006 lanius 1.133
1007 vapier 1.167 local title=$1
1008     local command=$2
1009 vapier 1.314 local desktop=${T}/${wm:-${PN}}.desktop
1010     shift 2
1011 lanius 1.133
1012 vapier 1.271 cat <<-EOF > "${desktop}"
1013     [Desktop Entry]
1014     Name=${title}
1015     Comment=This session logs you into ${title}
1016 vapier 1.314 Exec=${command} $*
1017 vapier 1.271 TryExec=${command}
1018 vapier 1.314 Type=XSession
1019 vapier 1.271 EOF
1020 lanius 1.133
1021 vapier 1.271 (
1022     # wrap the env here so that the 'insinto' call
1023     # doesn't corrupt the env of the caller
1024 lanius 1.133 insinto /usr/share/xsessions
1025     doins "${desktop}"
1026 vapier 1.271 )
1027 lanius 1.133 }
1028    
1029 vapier 1.283 # @FUNCTION: domenu
1030     # @USAGE: <menus>
1031     # @DESCRIPTION:
1032     # Install the list of .desktop menu files into the appropriate directory
1033     # (/usr/share/applications).
1034 lanius 1.133 domenu() {
1035 vapier 1.271 (
1036     # wrap the env here so that the 'insinto' call
1037     # doesn't corrupt the env of the caller
1038     local i j ret=0
1039 lanius 1.133 insinto /usr/share/applications
1040 vapier 1.167 for i in "$@" ; do
1041     if [[ -f ${i} ]] ; then
1042     doins "${i}"
1043 vapier 1.271 ((ret+=$?))
1044 vapier 1.167 elif [[ -d ${i} ]] ; then
1045     for j in "${i}"/*.desktop ; do
1046     doins "${j}"
1047 vapier 1.271 ((ret+=$?))
1048 lanius 1.133 done
1049 vapier 1.285 else
1050     ((++ret))
1051 swegener 1.190 fi
1052 lanius 1.133 done
1053 vapier 1.271 exit ${ret}
1054     )
1055 lanius 1.133 }
1056 vapier 1.283
1057     # @FUNCTION: newmenu
1058     # @USAGE: <menu> <newname>
1059     # @DESCRIPTION:
1060     # Like all other new* functions, install the specified menu as newname.
1061 vapier 1.167 newmenu() {
1062 vapier 1.271 (
1063     # wrap the env here so that the 'insinto' call
1064     # doesn't corrupt the env of the caller
1065 vapier 1.167 insinto /usr/share/applications
1066 vapier 1.271 newins "$@"
1067     )
1068 vapier 1.167 }
1069 lanius 1.133
1070 hasufell 1.394 # @FUNCTION: _iconins
1071     # @INTERNAL
1072 vapier 1.283 # @DESCRIPTION:
1073 hasufell 1.394 # function for use in doicon and newicon
1074     _iconins() {
1075 vapier 1.271 (
1076     # wrap the env here so that the 'insinto' call
1077     # doesn't corrupt the env of the caller
1078 hasufell 1.394 local funcname=$1; shift
1079     local size dir
1080     local context=apps
1081     local theme=hicolor
1082    
1083     while [[ $# -gt 0 ]] ; do
1084     case $1 in
1085     -s|--size)
1086     if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1087     size=${2%%x*}
1088     else
1089     size=${2}
1090     fi
1091     case ${size} in
1092 williamh 1.441 16|22|24|32|36|48|64|72|96|128|192|256|512)
1093 hasufell 1.394 size=${size}x${size};;
1094     scalable)
1095     ;;
1096     *)
1097     eerror "${size} is an unsupported icon size!"
1098     exit 1;;
1099     esac
1100     shift 2;;
1101     -t|--theme)
1102     theme=${2}
1103     shift 2;;
1104     -c|--context)
1105     context=${2}
1106     shift 2;;
1107     *)
1108     if [[ -z ${size} ]] ; then
1109     insinto /usr/share/pixmaps
1110     else
1111     insinto /usr/share/icons/${theme}/${size}/${context}
1112     fi
1113    
1114     if [[ ${funcname} == doicon ]] ; then
1115     if [[ -f $1 ]] ; then
1116     doins "${1}"
1117     elif [[ -d $1 ]] ; then
1118     shopt -s nullglob
1119     doins "${1}"/*.{png,svg}
1120     shopt -u nullglob
1121     else
1122     eerror "${1} is not a valid file/directory!"
1123     exit 1
1124     fi
1125     else
1126     break
1127     fi
1128     shift 1;;
1129     esac
1130 lanius 1.133 done
1131 hasufell 1.394 if [[ ${funcname} == newicon ]] ; then
1132     newins "$@"
1133     fi
1134     ) || die
1135     }
1136    
1137     # @FUNCTION: doicon
1138     # @USAGE: [options] <icons>
1139     # @DESCRIPTION:
1140     # Install icon into the icon directory /usr/share/icons or into
1141     # /usr/share/pixmaps if "--size" is not set.
1142     # This is useful in conjunction with creating desktop/menu files.
1143     #
1144     # @CODE
1145     # options:
1146     # -s, --size
1147     # !!! must specify to install into /usr/share/icons/... !!!
1148     # size of the icon, like 48 or 48x48
1149     # supported icon sizes are:
1150     # 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1151     # -c, --context
1152     # defaults to "apps"
1153     # -t, --theme
1154     # defaults to "hicolor"
1155     #
1156     # icons: list of icons
1157     #
1158 hasufell 1.398 # example 1: doicon foobar.png fuqbar.svg suckbar.png
1159 hasufell 1.394 # results in: insinto /usr/share/pixmaps
1160 hasufell 1.398 # doins foobar.png fuqbar.svg suckbar.png
1161 hasufell 1.394 #
1162 ssuominen 1.399 # example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1163 hasufell 1.394 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1164 ssuominen 1.399 # doins foobar.png fuqbar.png blobbar.png
1165 hasufell 1.394 # @CODE
1166     doicon() {
1167     _iconins ${FUNCNAME} "$@"
1168 lanius 1.133 }
1169 vapier 1.283
1170     # @FUNCTION: newicon
1171 hasufell 1.394 # @USAGE: [options] <icon> <newname>
1172 vapier 1.283 # @DESCRIPTION:
1173 hasufell 1.394 # Like doicon, install the specified icon as newname.
1174     #
1175     # @CODE
1176     # example 1: newicon foobar.png NEWNAME.png
1177     # results in: insinto /usr/share/pixmaps
1178     # newins foobar.png NEWNAME.png
1179     #
1180 ulm 1.435 # example 2: newicon -s 48 foobar.png NEWNAME.png
1181 hasufell 1.394 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1182     # newins foobar.png NEWNAME.png
1183     # @CODE
1184 vapier 1.167 newicon() {
1185 hasufell 1.394 _iconins ${FUNCNAME} "$@"
1186 vapier 1.167 }
1187 lanius 1.133
1188 vapier 1.287 # @FUNCTION: strip-linguas
1189     # @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1190     # @DESCRIPTION:
1191 mr_bones_ 1.100 # Make sure that LINGUAS only contains languages that
1192 vapier 1.287 # a package can support. The first form allows you to
1193     # specify a list of LINGUAS. The -i builds a list of po
1194     # files found in all the directories and uses the
1195     # intersection of the lists. The -u builds a list of po
1196     # files found in all the directories and uses the union
1197     # of the lists.
1198 vapier 1.92 strip-linguas() {
1199 vapier 1.242 local ls newls nols
1200 vapier 1.154 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1201     local op=$1; shift
1202 vapier 1.315 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1203 vapier 1.92 local d f
1204     for d in "$@" ; do
1205 vapier 1.154 if [[ ${op} == "-u" ]] ; then
1206     newls=${ls}
1207 vapier 1.92 else
1208     newls=""
1209     fi
1210 vapier 1.315 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1211 vapier 1.154 if [[ ${op} == "-i" ]] ; then
1212 ssuominen 1.358 has ${f} ${ls} && newls="${newls} ${f}"
1213 vapier 1.92 else
1214 ssuominen 1.358 has ${f} ${ls} || newls="${newls} ${f}"
1215 vapier 1.92 fi
1216     done
1217 vapier 1.154 ls=${newls}
1218 vapier 1.92 done
1219     else
1220 vapier 1.236 ls="$@"
1221 vapier 1.92 fi
1222    
1223 vapier 1.242 nols=""
1224 vapier 1.92 newls=""
1225     for f in ${LINGUAS} ; do
1226 ssuominen 1.358 if has ${f} ${ls} ; then
1227 vapier 1.120 newls="${newls} ${f}"
1228 vapier 1.92 else
1229 vapier 1.242 nols="${nols} ${f}"
1230 vapier 1.92 fi
1231     done
1232 vapier 1.244 [[ -n ${nols} ]] \
1233 pacho 1.388 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1234 vapier 1.237 export LINGUAS=${newls:1}
1235 vapier 1.92 }
1236 iggy 1.110
1237 vapier 1.283 # @FUNCTION: preserve_old_lib
1238     # @USAGE: <libs to preserve> [more libs]
1239     # @DESCRIPTION:
1240     # These functions are useful when a lib in your package changes ABI SONAME.
1241     # An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1242 eradicator 1.111 # would break packages that link against it. Most people get around this
1243     # by using the portage SLOT mechanism, but that is not always a relevant
1244 vapier 1.283 # solution, so instead you can call this from pkg_preinst. See also the
1245     # preserve_old_lib_notify function.
1246 eradicator 1.111 preserve_old_lib() {
1247 vapier 1.428 _eutils_eprefix_init
1248 vapier 1.268 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1249 vapier 1.267 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1250 vapier 1.276 die "Invalid preserve_old_lib() usage"
1251 vapier 1.267 fi
1252     [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1253    
1254 vapier 1.297 # let portage worry about it
1255     has preserve-libs ${FEATURES} && return 0
1256    
1257 vapier 1.267 local lib dir
1258     for lib in "$@" ; do
1259 vapier 1.428 [[ -e ${EROOT}/${lib} ]] || continue
1260 vapier 1.267 dir=${lib%/*}
1261     dodir ${dir} || die "dodir ${dir} failed"
1262 vapier 1.428 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1263     touch "${ED}"/${lib}
1264 vapier 1.267 done
1265 eradicator 1.111 }
1266    
1267 vapier 1.283 # @FUNCTION: preserve_old_lib_notify
1268     # @USAGE: <libs to notify> [more libs]
1269     # @DESCRIPTION:
1270     # Spit helpful messages about the libraries preserved by preserve_old_lib.
1271 eradicator 1.111 preserve_old_lib_notify() {
1272 vapier 1.268 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1273 vapier 1.267 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1274 vapier 1.276 die "Invalid preserve_old_lib_notify() usage"
1275 vapier 1.267 fi
1276    
1277 vapier 1.297 # let portage worry about it
1278     has preserve-libs ${FEATURES} && return 0
1279    
1280 vapier 1.428 _eutils_eprefix_init
1281 ulm 1.435
1282 vapier 1.267 local lib notice=0
1283     for lib in "$@" ; do
1284 vapier 1.428 [[ -e ${EROOT}/${lib} ]] || continue
1285 vapier 1.267 if [[ ${notice} -eq 0 ]] ; then
1286     notice=1
1287     ewarn "Old versions of installed libraries were detected on your system."
1288     ewarn "In order to avoid breaking packages that depend on these old libs,"
1289     ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1290     ewarn "in order to remove these old dependencies. If you do not have this"
1291     ewarn "helper program, simply emerge the 'gentoolkit' package."
1292     ewarn
1293     fi
1294 phajdan.jr 1.393 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1295 vapier 1.267 done
1296 eradicator 1.111 }
1297 vapier 1.125
1298 vapier 1.283 # @FUNCTION: built_with_use
1299     # @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1300     # @DESCRIPTION:
1301 betelgeuse 1.329 #
1302     # Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1303     #
1304 vapier 1.283 # A temporary hack until portage properly supports DEPENDing on USE
1305     # flags being enabled in packages. This will check to see if the specified
1306     # DEPEND atom was built with the specified list of USE flags. The
1307     # --missing option controls the behavior if called on a package that does
1308     # not actually support the defined USE flags (aka listed in IUSE).
1309     # The default is to abort (call die). The -a and -o flags control
1310     # the requirements of the USE flags. They correspond to "and" and "or"
1311     # logic. So the -a flag means all listed USE flags must be enabled
1312 opfer 1.302 # while the -o flag means at least one of the listed IUSE flags must be
1313 vapier 1.283 # enabled. The --hidden option is really for internal use only as it
1314     # means the USE flag we're checking is hidden expanded, so it won't be found
1315     # in IUSE like normal USE flags.
1316 swegener 1.286 #
1317 vapier 1.283 # Remember that this function isn't terribly intelligent so order of optional
1318     # flags matter.
1319 vapier 1.125 built_with_use() {
1320 vapier 1.428 _eutils_eprefix_init
1321 vapier 1.275 local hidden="no"
1322     if [[ $1 == "--hidden" ]] ; then
1323     hidden="yes"
1324     shift
1325     fi
1326    
1327 vapier 1.269 local missing_action="die"
1328     if [[ $1 == "--missing" ]] ; then
1329     missing_action=$2
1330     shift ; shift
1331     case ${missing_action} in
1332     true|false|die) ;;
1333     *) die "unknown action '${missing_action}'";;
1334     esac
1335     fi
1336    
1337 vapier 1.130 local opt=$1
1338     [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1339    
1340     local PKG=$(best_version $1)
1341 vapier 1.247 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1342 vapier 1.130 shift
1343    
1344 vapier 1.428 local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1345     local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1346 vapier 1.213
1347 cardoe 1.273 # if the IUSE file doesn't exist, the read will error out, we need to handle
1348     # this gracefully
1349 vapier 1.275 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1350 cardoe 1.273 case ${missing_action} in
1351     true) return 0;;
1352     false) return 1;;
1353     die) die "Unable to determine what USE flags $PKG was built with";;
1354     esac
1355     fi
1356    
1357 vapier 1.275 if [[ ${hidden} == "no" ]] ; then
1358 zmedico 1.301 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1359 vapier 1.275 # Don't check USE_EXPAND #147237
1360     local expand
1361     for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1362     if [[ $1 == ${expand}_* ]] ; then
1363     expand=""
1364     break
1365     fi
1366     done
1367     if [[ -n ${expand} ]] ; then
1368 zmedico 1.301 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1369 vapier 1.275 case ${missing_action} in
1370     true) return 0;;
1371     false) return 1;;
1372     die) die "$PKG does not actually support the $1 USE flag!";;
1373     esac
1374     fi
1375 vapier 1.269 fi
1376 vapier 1.250 fi
1377 vapier 1.249
1378 vapier 1.125 local USE_BUILT=$(<${USEFILE})
1379 vapier 1.130 while [[ $# -gt 0 ]] ; do
1380     if [[ ${opt} = "-o" ]] ; then
1381     has $1 ${USE_BUILT} && return 0
1382     else
1383     has $1 ${USE_BUILT} || return 1
1384     fi
1385 vapier 1.125 shift
1386     done
1387 vapier 1.130 [[ ${opt} = "-a" ]]
1388 vapier 1.125 }
1389 vapier 1.126
1390 vapier 1.289 # @FUNCTION: epunt_cxx
1391 vapier 1.283 # @USAGE: [dir to scan]
1392     # @DESCRIPTION:
1393     # Many configure scripts wrongly bail when a C++ compiler could not be
1394     # detected. If dir is not specified, then it defaults to ${S}.
1395     #
1396     # http://bugs.gentoo.org/73450
1397 vapier 1.126 epunt_cxx() {
1398 vapier 1.127 local dir=$1
1399     [[ -z ${dir} ]] && dir=${S}
1400     ebegin "Removing useless C++ checks"
1401 vapier 1.415 local f p any_found
1402 mgorny 1.412 while IFS= read -r -d '' f; do
1403 vapier 1.415 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1404     if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1405     any_found=1
1406     break
1407     fi
1408     done
1409 mgorny 1.412 done < <(find "${dir}" -name configure -print0)
1410 mgorny 1.410
1411 vapier 1.415 if [[ -z ${any_found} ]]; then
1412     eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1413     fi
1414 vapier 1.127 eend 0
1415 vapier 1.126 }
1416 ka0ttic 1.143
1417 vapier 1.283 # @FUNCTION: make_wrapper
1418 wolf31o2 1.295 # @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1419 vapier 1.283 # @DESCRIPTION:
1420     # Create a shell wrapper script named wrapper in installpath
1421     # (defaults to the bindir) to execute target (default of wrapper) by
1422     # first optionally setting LD_LIBRARY_PATH to the colon-delimited
1423     # libpaths followed by optionally changing directory to chdir.
1424 wolf31o2 1.160 make_wrapper() {
1425 vapier 1.428 _eutils_eprefix_init
1426 wolf31o2 1.164 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1427 wolf31o2 1.160 local tmpwrapper=$(emktemp)
1428 vapier 1.414
1429     (
1430     echo '#!/bin/sh'
1431 vapier 1.428 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1432 vapier 1.414 if [[ -n ${libdir} ]] ; then
1433 vapier 1.428 local var
1434     if [[ ${CHOST} == *-darwin* ]] ; then
1435     var=DYLD_LIBRARY_PATH
1436     else
1437     var=LD_LIBRARY_PATH
1438     fi
1439 vapier 1.414 cat <<-EOF
1440 vapier 1.428 if [ "\${${var}+set}" = "set" ] ; then
1441     export ${var}="\${${var}}:${EPREFIX}${libdir}"
1442 vapier 1.414 else
1443 vapier 1.428 export ${var}="${EPREFIX}${libdir}"
1444 vapier 1.414 fi
1445     EOF
1446     fi
1447 vapier 1.202 # We don't want to quote ${bin} so that people can pass complex
1448 vapier 1.414 # things as ${bin} ... "./someprog --args"
1449 vapier 1.439 printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}/}"
1450 vapier 1.414 ) > "${tmpwrapper}"
1451 wolf31o2 1.160 chmod go+rx "${tmpwrapper}"
1452 vapier 1.414
1453 vapier 1.201 if [[ -n ${path} ]] ; then
1454 vapier 1.283 (
1455 vapier 1.201 exeinto "${path}"
1456 wolf31o2 1.164 newexe "${tmpwrapper}" "${wrapper}"
1457 vapier 1.283 ) || die
1458 wolf31o2 1.164 else
1459 vapier 1.283 newbin "${tmpwrapper}" "${wrapper}" || die
1460 wolf31o2 1.164 fi
1461 wolf31o2 1.160 }
1462 mr_bones_ 1.311
1463 vapier 1.351 # @FUNCTION: path_exists
1464     # @USAGE: [-a|-o] <paths>
1465     # @DESCRIPTION:
1466     # Check if the specified paths exist. Works for all types of paths
1467     # (files/dirs/etc...). The -a and -o flags control the requirements
1468     # of the paths. They correspond to "and" and "or" logic. So the -a
1469     # flag means all the paths must exist while the -o flag means at least
1470     # one of the paths must exist. The default behavior is "and". If no
1471     # paths are specified, then the return value is "false".
1472     path_exists() {
1473     local opt=$1
1474     [[ ${opt} == -[ao] ]] && shift || opt="-a"
1475    
1476     # no paths -> return false
1477     # same behavior as: [[ -e "" ]]
1478     [[ $# -eq 0 ]] && return 1
1479    
1480     local p r=0
1481     for p in "$@" ; do
1482     [[ -e ${p} ]]
1483     : $(( r += $? ))
1484     done
1485    
1486     case ${opt} in
1487     -a) return $(( r != 0 )) ;;
1488     -o) return $(( r == $# )) ;;
1489     esac
1490     }
1491 mgorny 1.364
1492     # @FUNCTION: in_iuse
1493     # @USAGE: <flag>
1494     # @DESCRIPTION:
1495     # Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1496     # as necessary.
1497     #
1498     # Note that this function should not be used in the global scope.
1499     in_iuse() {
1500     debug-print-function ${FUNCNAME} "${@}"
1501     [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1502    
1503     local flag=${1}
1504     local liuse=( ${IUSE} )
1505    
1506     has "${flag}" "${liuse[@]#[+-]}"
1507     }
1508 vapier 1.365
1509 vapier 1.367 # @FUNCTION: use_if_iuse
1510     # @USAGE: <flag>
1511     # @DESCRIPTION:
1512     # Return true if the given flag is in USE and IUSE.
1513     #
1514     # Note that this function should not be used in the global scope.
1515     use_if_iuse() {
1516     in_iuse $1 || return 1
1517     use $1
1518     }
1519    
1520 vapier 1.365 # @FUNCTION: usex
1521     # @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1522     # @DESCRIPTION:
1523 axs 1.404 # Proxy to declare usex for package managers or EAPIs that do not provide it
1524     # and use the package manager implementation when available (i.e. EAPI >= 5).
1525 vapier 1.365 # If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1526     # otherwise echo [false output][false suffix] (defaults to "no").
1527 ulm 1.405 if has "${EAPI:-0}" 0 1 2 3 4; then
1528 axs 1.404 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1529     fi
1530 vapier 1.371
1531 mgorny 1.395 # @FUNCTION: prune_libtool_files
1532 mgorny 1.408 # @USAGE: [--all|--modules]
1533 mgorny 1.395 # @DESCRIPTION:
1534     # Locate unnecessary libtool files (.la) and libtool static archives
1535     # (.a) and remove them from installation image.
1536     #
1537     # By default, .la files are removed whenever the static linkage can
1538     # either be performed using pkg-config or doesn't introduce additional
1539     # flags.
1540     #
1541 mgorny 1.408 # If '--modules' argument is passed, .la files for modules (plugins) are
1542     # removed as well. This is usually useful when the package installs
1543     # plugins and the plugin loader does not use .la files.
1544     #
1545     # If '--all' argument is passed, all .la files are removed without
1546     # performing any heuristic on them. You shouldn't ever use that,
1547     # and instead report a bug in the algorithm instead.
1548 mgorny 1.395 #
1549     # The .a files are only removed whenever corresponding .la files state
1550     # that they should not be linked to, i.e. whenever these files
1551     # correspond to plugins.
1552     #
1553 mgorny 1.411 # Note: if your package installs both static libraries and .pc files
1554     # which use variable substitution for -l flags, you need to add
1555     # pkg-config to your DEPEND.
1556 mgorny 1.395 prune_libtool_files() {
1557     debug-print-function ${FUNCNAME} "$@"
1558    
1559 mgorny 1.408 local removing_all removing_modules opt
1560 vapier 1.428 _eutils_eprefix_init
1561 mgorny 1.395 for opt; do
1562     case "${opt}" in
1563     --all)
1564     removing_all=1
1565 mgorny 1.408 removing_modules=1
1566     ;;
1567     --modules)
1568     removing_modules=1
1569 mgorny 1.395 ;;
1570     *)
1571     die "Invalid argument to ${FUNCNAME}(): ${opt}"
1572     esac
1573     done
1574    
1575     local f
1576 mgorny 1.407 local queue=()
1577 mgorny 1.395 while IFS= read -r -d '' f; do # for all .la files
1578     local archivefile=${f/%.la/.a}
1579    
1580 mgorny 1.420 # The following check is done by libtool itself.
1581     # It helps us avoid removing random files which match '*.la',
1582     # see bug #468380.
1583 mgorny 1.421 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1584 mgorny 1.420 continue
1585     fi
1586    
1587 mgorny 1.395 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1588 mgorny 1.442 local reason= pkgconfig_scanned=
1589 mgorny 1.418 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1590 mgorny 1.395
1591 mgorny 1.418 if [[ ${snotlink} == yes ]]; then
1592 mgorny 1.408
1593 mgorny 1.418 # Remove static libs we're not supposed to link against.
1594 mgorny 1.400 if [[ -f ${archivefile} ]]; then
1595     einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1596 mgorny 1.407 queue+=( "${archivefile}" )
1597 mgorny 1.400 fi
1598 mgorny 1.395
1599     # The .la file may be used by a module loader, so avoid removing it
1600     # unless explicitly requested.
1601 mgorny 1.408 if [[ ${removing_modules} ]]; then
1602     reason='module'
1603     fi
1604 mgorny 1.395
1605 mgorny 1.420 else
1606 mgorny 1.418
1607     # Remove .la files when:
1608     # - user explicitly wants us to remove all .la files,
1609     # - respective static archive doesn't exist,
1610     # - they are covered by a .pc file already,
1611     # - they don't provide any new information (no libs & no flags).
1612    
1613     if [[ ${removing_all} ]]; then
1614     reason='requested'
1615     elif [[ ! -f ${archivefile} ]]; then
1616     reason='no static archive'
1617     elif [[ ! $(sed -nre \
1618     "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1619     "${f}") ]]; then
1620     reason='no libs & flags'
1621     else
1622     if [[ ! ${pkgconfig_scanned} ]]; then
1623     # Create a list of all .pc-covered libs.
1624     local pc_libs=()
1625     if [[ ! ${removing_all} ]]; then
1626     local pc
1627     local tf=${T}/prune-lt-files.pc
1628     local pkgconf=$(tc-getPKG_CONFIG)
1629    
1630     while IFS= read -r -d '' pc; do # for all .pc files
1631     local arg libs
1632    
1633     # Use pkg-config if available (and works),
1634     # fallback to sed.
1635     if ${pkgconf} --exists "${pc}" &>/dev/null; then
1636     sed -e '/^Requires:/d' "${pc}" > "${tf}"
1637     libs=$(${pkgconf} --libs "${tf}")
1638     else
1639     libs=$(sed -ne 's/^Libs://p' "${pc}")
1640     fi
1641    
1642     for arg in ${libs}; do
1643     if [[ ${arg} == -l* ]]; then
1644     if [[ ${arg} == '*$*' ]]; then
1645     eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1646     eqawarn "(arg: ${arg})"
1647     eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1648     fi
1649    
1650     pc_libs+=( lib${arg#-l}.la )
1651 mgorny 1.411 fi
1652 mgorny 1.418 done
1653     done < <(find "${D}" -type f -name '*.pc' -print0)
1654 mgorny 1.411
1655 mgorny 1.418 rm -f "${tf}"
1656     fi
1657 mgorny 1.402
1658 mgorny 1.418 pkgconfig_scanned=1
1659     fi # pkgconfig_scanned
1660 mgorny 1.402
1661 mgorny 1.418 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1662     fi # removal due to .pc
1663 mgorny 1.402
1664 mgorny 1.418 fi # shouldnotlink==no
1665 mgorny 1.395
1666     if [[ ${reason} ]]; then
1667     einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1668 mgorny 1.407 queue+=( "${f}" )
1669 mgorny 1.395 fi
1670 vapier 1.428 done < <(find "${ED}" -xtype f -name '*.la' -print0)
1671 mgorny 1.407
1672     if [[ ${queue[@]} ]]; then
1673     rm -f "${queue[@]}"
1674     fi
1675 mgorny 1.395 }
1676    
1677 mgorny 1.430 # @FUNCTION: einstalldocs
1678 mgorny 1.429 # @DESCRIPTION:
1679     # Install documentation using DOCS and HTML_DOCS.
1680     #
1681     # If DOCS is declared and non-empty, all files listed in it are
1682     # installed. The files must exist, otherwise the function will fail.
1683     # In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
1684     # in other EAPIs using directories is unsupported.
1685     #
1686     # If DOCS is not declared, the files matching patterns given
1687     # in the default EAPI implementation of src_install will be installed.
1688     # If this is undesired, DOCS can be set to empty value to prevent any
1689     # documentation from being installed.
1690     #
1691     # If HTML_DOCS is declared and non-empty, all files and/or directories
1692     # listed in it are installed as HTML docs (using dohtml).
1693     #
1694     # Both DOCS and HTML_DOCS can either be an array or a whitespace-
1695     # separated list. Whenever directories are allowed, '<directory>/.' may
1696     # be specified in order to install all files within the directory
1697     # without creating a sub-directory in docdir.
1698     #
1699     # Passing additional options to dodoc and dohtml is not supported.
1700     # If you needed such a thing, you need to call those helpers explicitly.
1701 mgorny 1.426 einstalldocs() {
1702     debug-print-function ${FUNCNAME} "${@}"
1703    
1704 mgorny 1.427 local dodoc_opts=-r
1705     has ${EAPI} 0 1 2 3 && dodoc_opts=
1706    
1707 mgorny 1.426 if ! declare -p DOCS &>/dev/null ; then
1708     local d
1709     for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1710     THANKS BUGS FAQ CREDITS CHANGELOG ; do
1711 mgorny 1.427 if [[ -s ${d} ]] ; then
1712     dodoc "${d}" || die
1713     fi
1714 mgorny 1.426 done
1715     elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
1716 mgorny 1.427 if [[ ${DOCS[@]} ]] ; then
1717     dodoc ${dodoc_opts} "${DOCS[@]}" || die
1718     fi
1719 mgorny 1.426 else
1720 mgorny 1.427 if [[ ${DOCS} ]] ; then
1721     dodoc ${dodoc_opts} ${DOCS} || die
1722     fi
1723 mgorny 1.426 fi
1724    
1725     if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1726 mgorny 1.427 if [[ ${HTML_DOCS[@]} ]] ; then
1727     dohtml -r "${HTML_DOCS[@]}" || die
1728     fi
1729 mgorny 1.426 else
1730 mgorny 1.427 if [[ ${HTML_DOCS} ]] ; then
1731     dohtml -r ${HTML_DOCS} || die
1732     fi
1733 mgorny 1.426 fi
1734    
1735     return 0
1736     }
1737    
1738 vapier 1.372 check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1739    
1740 creffett 1.432 # @FUNCTION: optfeature
1741     # @USAGE: <short description> <package atom to match> [other atoms]
1742     # @DESCRIPTION:
1743     # Print out a message suggesting an optional package (or packages) which
1744     # provide the described functionality
1745     #
1746     # The following snippet would suggest app-misc/foo for optional foo support,
1747     # app-misc/bar or app-misc/baz[bar] for optional bar support
1748     # and either both app-misc/a and app-misc/b or app-misc/c for alphabet support.
1749 vapier 1.433 # @CODE
1750     # optfeature "foo support" app-misc/foo
1751     # optfeature "bar support" app-misc/bar app-misc/baz[bar]
1752     # optfeature "alphabet support" "app-misc/a app-misc/b" app-misc/c
1753     # @CODE
1754 creffett 1.432 optfeature() {
1755     debug-print-function ${FUNCNAME} "$@"
1756     local i j msg
1757     local desc=$1
1758     local flag=0
1759     shift
1760     for i; do
1761 vapier 1.433 for j in ${i}; do
1762     if has_version "${j}"; then
1763 creffett 1.432 flag=1
1764     else
1765     flag=0
1766     break
1767     fi
1768     done
1769 vapier 1.433 if [[ ${flag} -eq 1 ]]; then
1770 creffett 1.432 break
1771     fi
1772     done
1773 vapier 1.433 if [[ ${flag} -eq 0 ]]; then
1774 creffett 1.432 for i; do
1775     msg=" "
1776 vapier 1.433 for j in ${i}; do
1777     msg+=" ${j} and"
1778 creffett 1.432 done
1779     msg="${msg:0: -4} for ${desc}"
1780     elog "${msg}"
1781     done
1782     fi
1783     }
1784    
1785 vapier 1.371 fi

  ViewVC Help
Powered by ViewVC 1.1.20